#include "Game.hpp"

#include "scenes/DifficultyScene.hpp"
#include "scenes/GameOverScene.hpp"
#include "scenes/GameScene.hpp"
#include "scenes/HighscoreScene.hpp"
#include "scenes/MainMenuScene.hpp"
#include "scenes/SkillScene.hpp"
#include "scenes/SubmitScoreScene.hpp"

Game::Game()
   : GameBase::GameBase( 50, 50 )
{
}

void Game::initialize()
{
	GameBase::initialize();
	window.setTitle( "Swarm" );

	addScene( "Menu", std::shared_ptr< Scene >( new MainMenuScene( * this ) ) );

	addScene( "Game Difficulty", std::shared_ptr< Scene >( new DifficultyScene( ( * this ), "Skills" ) ) );
	addScene( "Skills", std::shared_ptr< Scene >( new SkillScene( * this ) ) );
	addScene( "Game", std::shared_ptr< Scene >( new GameScene( * this ) ) );
	addScene( "Game Over", std::shared_ptr< Scene >( new GameOverScene( * this ) ) );
	addScene( "Submit Score", std::shared_ptr< Scene >( new SubmitScoreScene( * this ) ) );
	
	addScene( "Difficulty Scores", std::shared_ptr< Scene >( new DifficultyScene( ( * this ), "Highscores" ) ) );
	addScene( "Highscores", std::shared_ptr< Scene >( new HighscoreScene( * this ) ) );

	changeScenes( "Menu", SceneChangeEvent() );
	
	music.openFromFile( "res/music.ogg" );
	music.setVolume( 30 );
	music.play();
}

void Game::terminate()
{
	GameBase::initialize();
}
