#ifndef GAME_ENEMY_HPP
#define GAME_ENEMY_HPP

#include <array>
#include <SFML/Graphics/ConvexShape.hpp>
#include <SFML/Graphics/Rect.hpp>
#include <SFML/Graphics/View.hpp>
#include <SFML/System/Vector2.hpp>

#include "game/Object.hpp"
#include "game/SkillType.hpp"

namespace game
{
	class Enemy : public Object
	{
		public:
			Enemy( Game& theGame, GameScene& theScene, World& theWorld, sf::Vector2f pos );
			
			virtual void update();
			virtual void render( sf::RenderWindow& window );
			
			sf::FloatRect getCollisionRect() const;
		
		private:
			sf::ConvexShape shape;
			sf::FloatRect coll;
			sf::Vector2f vel;
			int shoot;
			
			sf::Uint64 timeAlive;
			int orbitDir;
			int accuracy;
			int swerviness;
			float speediness;
			float bulletSpeed;
			int reloadTime;
			
			enum AiType
			{
				Straight = 0,
				Swerve = 1,
				Orbit = 2,
				Still = 3,
				Count,
			} ai;
			bool canShoot;
	};
}

#endif // GAME_ENEMY_HPP
