#ifndef GAME_OBJECT_HPP
#define GAME_OBJECT_HPP

namespace sf
{
	class Event;
	class RenderWindow;
}

class Game;
class GameScene;

namespace game
{
	class World;
	
	class Object
	{
		public:
			Object( Game& theGame, GameScene& theScene, World& theWorld );
			virtual ~Object();
			
			virtual void update();
			virtual void update( const sf::Event& event );
			virtual void render( sf::RenderWindow& window );
		
		protected:
			Game& game;
			GameScene& scene;
			World& world;
	};
}

#endif // GAME_OBJECT_HPP
