#ifndef GAME_PROJECTILE_HPP
#define GAME_PROJECTILE_HPP

#include <SFML/Audio/Sound.hpp>
#include <SFML/Graphics/CircleShape.hpp>

#include "game/Object.hpp"

namespace game
{
	class Projectile : public Object
	{
		public:
			Projectile( Game& theGame, GameScene& theScene, World& theWorld, sf::Vector2f pos, float dir, float theSpeed, bool thePlayer, int life );
			
			virtual void update();
			virtual void render( sf::RenderWindow& window );
			
			bool isPlayer() const;
			sf::FloatRect getCollisionRect() const;
			
			void damage();
			int getLife() const;
		
		private:
			sf::Sound sound;
			sf::CircleShape shape;
			const float speed;
			const bool player;
			int life;
			
			int age;
	};
}

#endif // GAME_PROJECTILE_HPP
