#ifndef GAME_WORLD_HPP
#define GAME_WORLD_HPP

#include <list>
#include <memory>
#include <SFML/Graphics/Rect.hpp>

#include "game/Object.hpp"

namespace game
{
	class World
	{
		public:
			void update();
			void update( const sf::Event& event );
			void render( sf::RenderWindow& window );
			
			void addObject( Object* obj ); // Shortcut for below
			void addObject( std::shared_ptr< Object > obj );
			void removeObject( Object* obj );
			void removeObject( std::shared_ptr< Object > obj );
			std::list< std::shared_ptr< Object > >& getObjects();
			const std::list< std::shared_ptr< Object > >& getObjects() const;
			
			sf::FloatRect getBounds() const;
		
		private:
			std::list< std::shared_ptr< Object > > objects;
			std::list< std::shared_ptr< Object > > pendingRemoval;
			std::list< std::shared_ptr< Object > > pendingAddition;
	};
}

#endif // GAME_WORLD_HPP
