#include "scenes/GameOverScene.hpp"

#include <array>
#include <SFML/Graphics/Font.hpp>
#include <SFML/Graphics/RenderWindow.hpp>
#include <SFML/Graphics/Sprite.hpp>
#include <SFML/Graphics/Text.hpp>
#include <SFML/Graphics/Texture.hpp>
#include <string>

#include "Game.hpp"
#include "game/Player.hpp"

GameOverScene::GameOverScene( Game& theGame )
   : MenuScene::MenuScene( theGame )
{
}

void GameOverScene::renderImpl( sf::RenderWindow& window )
{
	sf::Vector2i mouse = sf::Mouse::getPosition( window );
	
	sf::Font& font = ( * game.getFont( "res/dejavu/ttf/DejaVuSans.ttf" ) );
	sf::Texture& button = ( * game.getTexture( "res/button/rectangle.png" ) );
	
	sf::Text text;
	text.setFont( font );
	text.setColor( sf::Color::Black );
	text.setCharacterSize( 50 );
	text.setString( "You Lose!" );
	text.setPosition( 320 - static_cast< int >( text.getLocalBounds().width / 2 ), 185 );
	window.draw( text );
	
	sf::Sprite spr;
	spr.setTexture( button, true );
	spr.setPosition( 320 - 128, 350 );
	window.draw( spr );
	
	text.setString( "Back" );
	text.setCharacterSize( 35 );
	text.setPosition( 320 - 128 + static_cast< int >( ( button.getSize().x - text.getLocalBounds().width ) / 2 ), 350 );
	window.draw( text );
	
	if ( justPressed and spr.getGlobalBounds().contains( mouse.x, mouse.y ) )
	{
		game.changeScenes( "Menu" );
	}
}
