#ifndef GAMESCENE_HPP
#define GAMESCENE_HPP

#include "Scene.hpp"
#include "game/World.hpp"

namespace game
{
	class Player;
}

class GameScene : public Scene
{
	public:
		GameScene( Game& theGame );
	
		virtual void initialize( SceneChangeEvent& event );
		virtual void terminate();
		
		virtual void update();
		virtual void update( const sf::Event& event );
		virtual void render( sf::RenderWindow& window );
		
		int points;
		int getDifficulty() const;
		game::Player& getPlayer();
		const game::Player& getPlayer() const;
	
	private:
		std::shared_ptr< game::World > world;
		game::Player* player;
		int difficulty;
		
		int spawnTimer;
		int finishTimer;
};

#endif // GAMESCENE_HPP
