#ifndef MENUSCENE_HPP
#define MENUSCENE_HPP

#include <SFML/Audio/Sound.hpp>
#include <SFML/Graphics/ConvexShape.hpp>
#include <string>
#include <vector>

#include "Scene.hpp"

class MenuScene : public Scene
{
	public:
		MenuScene( Game& theGame );
	
		virtual void initialize( SceneChangeEvent& event );
		virtual void terminate();
		
		virtual void update();
		virtual void update( const sf::Event& event );
		virtual void render( sf::RenderWindow& window );
	
	protected:
		std::string subtitle;
		bool justPressed;
		
		void drawTitle( sf::RenderWindow& window );
		virtual void renderImpl( sf::RenderWindow& window ) = 0;
		
		static int titleTimer;
		static sf::ConvexShape base;
		static std::vector< sf::ConvexShape > original;
		
		sf::Sound titleSound;
		std::vector< sf::ConvexShape > curr;
		void loadTitleData();
		void drawFancyTitle( sf::RenderWindow& window );
};

#endif // MENUSCENE_HPP
